
create table test (
 id int primary key,
 value int
)

declare @x int = 1;
begin transaction
while (@x <= 10000)
begin
  insert into test values(@x, RAND()*10000);
  set @x += 1;
end
commit

-- ~3000 rows
select * from test where value > 7000

create index f1 on test(value) where value > 7000

alter database tempdb set parameterization simple

-- uses f1
select * from test where value > 7000

alter database tempdb set parameterization forced

-- auto-parameterized and doesn't use f1
select * from test where value > 7000

alter database tempdb set parameterization simple
go

create procedure select_from_test (@value int)
as
begin
  select * from test where value > @value 
end
go

-- doesn't use index f1
execute select_from_test 7000
go

create procedure select_small (@value int)
as
begin
  select * from test where value > @value 
end
go

create procedure select_from_test2 (@value int)
as
begin
  if @value < 7000
  begin 
    execute select_small @value
    return
  end
  
  -- only get here if you're going to use f1
  select * from test where value > 7000 and value > @value
end

execute select_from_test2 7000
go

-- uses index f1
execute select_from_test2 8035

dbcc freeproccache
go

-- lower value first
execute select_from_test2 5000

-- high value second
execute select_from_test2 8035
go

create procedure select_small3 (@value int)
as
begin
  select * from test where value = @value 
end
go

create procedure select_from_test3 (@value int)
as
begin
  if @value < 7000
  begin 
    execute select_small3 @value
    return
  end
  
  -- only get here if you're going to use f1
  select * from test where value > 7000 and value = @value
end

dbcc freeproccache
go

-- lower value first
execute select_from_test3 5000

-- high value second
execute select_from_test3 8035
go